#include "DataFileReader_MSC.h"

#define _ThisClass      DataFileReader_MSC
#define _NumBaseClass   0


DataFileReader_MSC::DataFileReader_MSC()
{
    // initialize class
    InitializeDataFileReaderClass_DFR();
}


DataFileReader_MSC::DataFileReader_MSC(
    char * pcharFileName)
{
    // initialize class
    InitializeDataFileReaderClass_DFR();

    // load file during construction
    LoadDataFile_DFR(pcharFileName);
}


DataFileReader_MSC::~DataFileReader_MSC()
{
    // free memory
    if (pvoid_FileBuffer)
    {
    // clear buffer
    delete[]pvoid_FileBuffer;
    pvoid_FileBuffer = NULL;
    }
    else {}
}


void * DataFileReader_MSC::GetDataPointer_DFR()
{
    // return pointer to start of data
    return(pvoid_DataStart);
}


unsigned long DataFileReader_MSC::GetFileSize_DFR()
{
    // return file size
    return(ul_FileSize);
}


void * DataFileReader_MSC::GetHeaderPointer_DFR()
{
    // return pointer to start of header
    return(pvoid_HeaderStart);
}


void DataFileReader_MSC::InitializeDataFileReaderClass_DFR()
{
    // set defaults
    pvoid_FileBuffer = NULL;
    pvoid_HeaderStart = NULL;
    pvoid_DataStart = NULL;
}


int DataFileReader_MSC::LoadDataFile_DFR(
    char * pcharFileName)
{
    // declare local variables
    FILE *hFile;
    int iReturn;

    // check for previously loaded file
    if (pvoid_FileBuffer)
    {
    // clear previous buffer
    delete[]pvoid_FileBuffer;
    pvoid_FileBuffer = NULL;
    }
    else {}

    // open file
    hFile = fopen(pcharFileName, "rb");
    if (hFile)                            // valid stream returned from fopen function
    {
      // get file size
      fseek(hFile, 0L , SEEK_END);
      ul_FileSize = ftell(hFile);

      if (ul_FileSize > 0)                  // valid file size
      {
        // get memory for file
        pvoid_FileBuffer = new unsigned char [ul_FileSize];

        // load file into buffer
        rewind(hFile);
        if (fread(pvoid_FileBuffer, sizeof(unsigned char), ul_FileSize, hFile))
        {
          // set internal pointers
          pvoid_HeaderStart = pvoid_FileBuffer;
          pvoid_DataStart = pvoid_FileBuffer;

          // file loaded ok
          iReturn = FILE_OK_DFR;
        }
        else
        {
          // ERROR -- load failure
          iReturn = ERROR_FILE_LOAD_DFR;
        }
      }
      else
      {
        // ERROR -- seek failure
        iReturn = ERROR_FILE_SEEK_DFR;
      }
    }
    else
    {
    // ERROR -- file not opened
    iReturn = ERROR_FILE_OPEN_DFR;
    }

    // return results
    return(iReturn);
}


void DataFileReader_MSC::SetDataPointer_DFR(
    void *pvoidStart)
{
    // set internal pointer to start of data
    pvoid_DataStart = pvoidStart;
}


void DataFileReader_MSC::SetHeaderPointer_DFR(
    void *pvoidStart)
{
    // set internal pointer to start of header
    pvoid_HeaderStart = pvoidStart;
}


#undef _ThisClass
#undef _NumBaseClass

