/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __PARAMS_H__
#define __PARAMS_H__


class IDLParam 
{
public:
  string         cpp_options;
  string         name;
  string         file;
  string         cpp_suffix;
  string         c_suffix;
  string         hh_suffix;
  string         h_suffix;
  bool           relative_paths;
  string         repo_id;
  vector<string> inc_paths;
  bool           feed_ir;
  bool           feed_included_defs;
  bool           codegen_cpp;
  bool           cpp_impl;
  bool           codegen_c;
  bool           codegen_idl;
  bool           emit_repoids;
  bool           query_ir_for_narrow;
  bool           no_exceptions;
  bool           pseudo;
  bool           boa;
  bool           poa;
  bool           sii;

public:
  IDLParam( int argc, char *argv[] );
  
private:
  int    _argc;
  char** _argv;
  
  void set_defaults();
  void parse_params();
  void check_params();
  void usage();
};


#endif
