/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#include <CORBA.h>
#include <mico/template_impl.h>
#define CPP_WRAPPER

extern "C" {
#include "CORBA-c.h"

CORBA_ORB
CORBA_ORB_init(int *argcp,
	       char ***argvp,
	       const char *id)
{
  return CORBA::ORB_init(*argcp, *argvp, id);
}

CORBA_BOA
CORBA_BOA_init(CORBA_ORB orb,
	       int *argcp,
	       char ***argvp,
	       const char *id)
{
  return orb->BOA_init(*argcp, *argvp, id);
}

/* Pass in addr = NULL if you like */
CORBA_Object CORBA_ORB_bind(CORBA_ORB orb,
			    const char *repoid,
			    const char *addr)
{
  return orb->bind(repoid, addr);
}

CORBA_Object CORBA_ORB_string_to_object(CORBA_ORB orb,
					const char *iorstring)
{
  CORBA::String_var isref = iorstring;
  return orb->string_to_object(isref);
}

char *CORBA_ORB_object_to_string(CORBA_ORB orb,
				 CORBA_Object obj)
{
  return orb->object_to_string(obj);
}

CORBA_boolean
CORBA_Object_is_nil(CORBA_Object obj)
{
  return CORBA::is_nil(obj);
}

void
CORBA_BOA_impl_is_ready(CORBA_BOA boa, CORBA_Object obj)
{
  void *bar = obj;
  CORBA::ImplementationDef_ptr foo = (CORBA::ImplementationDef_ptr)bar;
  boa->impl_is_ready(foo);
}

void
CORBA_ORB_dispatcher(CORBA_ORB orb, CORBA_Dispatcher disp)
{
  orb->dispatcher(disp);
}

void
CORBA_ORB_run (CORBA_ORB orb)
{
  orb->run ();
}

}
