/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#include <CORBA.h>
#include <mico/template_impl.h>

/*
 * these methods are referenced by _var templates, which gcc 2.7.2
 * instantiates even if they are not used ...
 */

CORBA::DynAny_ptr
CORBA::DynAny::_nil ()
{
    return NULL;
}

CORBA::DynAny_ptr
CORBA::DynAny::_duplicate (DynAny_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynBasic_ptr
CORBA::DynBasic::_nil ()
{
    return NULL;
}

CORBA::DynBasic_ptr
CORBA::DynBasic::_duplicate (DynBasic_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynFixed_ptr
CORBA::DynFixed::_nil ()
{
    return NULL;
}

CORBA::DynFixed_ptr
CORBA::DynFixed::_duplicate (DynFixed_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynEnum_ptr
CORBA::DynEnum::_nil ()
{
    return NULL;
}

CORBA::DynEnum_ptr
CORBA::DynEnum::_duplicate (DynEnum_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynStruct_ptr
CORBA::DynStruct::_nil ()
{
    return NULL;
}

CORBA::DynStruct_ptr
CORBA::DynStruct::_duplicate (DynStruct_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynUnion_ptr
CORBA::DynUnion::_nil ()
{
    return NULL;
}

CORBA::DynUnion_ptr
CORBA::DynUnion::_duplicate (DynUnion_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynSequence_ptr
CORBA::DynSequence::_nil ()
{
    return NULL;
}

CORBA::DynSequence_ptr
CORBA::DynSequence::_duplicate (DynSequence_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}

CORBA::DynArray_ptr
CORBA::DynArray::_nil ()
{
    return NULL;
}

CORBA::DynArray_ptr
CORBA::DynArray::_duplicate (DynArray_ptr _obj)
{
    if( !CORBA::is_nil( _obj ) )
	_obj->_ref();
    return _obj;
}


// gcc 2.7.2 references this although not used; moved to orb/dynany.cc
#if 1
CORBA::NameValuePair::NameValuePair()
{
}

CORBA::NameValuePair::NameValuePair( const NameValuePair& _s )
{
    id = ((NameValuePair&)_s).id;
    value = ((NameValuePair&)_s).value;
}

CORBA::NameValuePair::~NameValuePair()
{
}

CORBA::NameValuePair&
CORBA::NameValuePair::operator=( const NameValuePair& _s )
{
    id = ((NameValuePair&)_s).id;
    value = ((NameValuePair&)_s).value;
    return *this;
}
#endif
