/*
  GEFAttr.c:  Attribute object of GEF.
  Copyright (C) 1998 Bruce W. Bigby, bbigby@alum.MIT.edu

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#include <stdio.h>
#include <GEFAttr.h>

void
GEFAttr_Init(GEFAttr_t* attrs) {
   attrs->Abort = NULL;
   attrs->AssertionViolation = NULL;
   attrs->UnhandledException = NULL;
   attrs->Exit = NULL;
   attrs->OSSignalToException = NULL;
   attrs->Error = NULL;
   attrs->OutOfMemory = NULL;
   attrs->UserCatch = NULL;
   attrs->Delete = NULL;
}

void
GEFAttr_SetAbort(GEFAttr_t* attrs, void (*callBack)(int)) {
   attrs->Abort = callBack;
}

void
GEFAttr_SetAssertionViolation(GEFAttr_t* attrs, void (*callBack)(char*, int)) {
   attrs->AssertionViolation = callBack;
}

void
GEFAttr_SetUnhandledException(GEFAttr_t* attrs, void (*callBack)(void*)) {
   attrs->UnhandledException = callBack;
}

void
GEFAttr_SetExit(GEFAttr_t* attrs, void (*callBack)(int)) {
   attrs->Exit = callBack;
}

void
GEFAttr_SetOutOfMemory(GEFAttr_t* attrs, void (*callBack)(void)) {
   attrs->OutOfMemory = callBack;
}

void
GEFAttr_SetOSSignalToException(GEFAttr_t* attrs, void* (*callBack)(int)) {
   attrs->OSSignalToException = callBack;
}

void
GEFAttr_SetError(GEFAttr_t* attrs, void (*callBack)(char* fmt, ...)) {
   attrs->Error = callBack;
}

void
GEFAttr_SetUserCatch(GEFAttr_t* attrs, void (*callBack)(void*, void*)) {
   attrs->UserCatch = callBack;
}

void
GEFAttr_SetDelete(GEFAttr_t* attrs, void (*callBack)(void**)) {
   attrs->Delete = callBack;
}

