/*
  GEF: A General Exception-Handling Facility, which also support "Programming by Contract."
  Copyright (C) 1998 Bruce W. Bigby
  EMail: bbigby@alum.MIT.edu
 */
#ifndef GEFATTR_H
#define GEFATTR_H

typedef struct {
   void (*Abort)(int);
   void (*AssertionViolation)(char*, int);
   void (*UnhandledException)(void*);
   void (*Exit)(int);
   void* (*OSSignalToException)(int);
   void (*Error)(char* format, ...);
   void (*OutOfMemory)(void);
   void (*UserCatch)(void* userData, void* exceptionID);
   void (*Delete)(void** exceptionID);
} GEFAttr_t;

extern
void
GEFAttr_Init(GEFAttr_t* attrs);

extern
void
GEFAttr_SetAbort(GEFAttr_t* attrs, void (*callBack)(int));

extern
void
GEFAttr_SetAssertionViolation(GEFAttr_t* attrs, void (*callBack)(char*, int));

extern
void
GEFAttr_SetUnhandledException(GEFAttr_t* attrs, void (*callBack)(void*));

extern
void
GEFAttr_SetExit(GEFAttr_t* attrs, void (*callBack)(int));

extern
void
GEFAttr_SetOutOfMemory(GEFAttr_t* attrs, void (*callBack)(void));

extern
void
GEFAttr_SetOSSignalToException(GEFAttr_t* attrs, void* (*callBack)(int));

extern
void
GEFAttr_SetError(GEFAttr_t* attrs, void (*callBack)(char* fmt, ...));

extern
void
GEFAttr_SetUserCatch(GEFAttr_t* attrs, void (*callBack)(void*, void*));

extern
void
GEFAttr_SetDelete(GEFAttr_t* attrs, void (*callBack)(void**));

#endif /* GEFATTR_H */
